<?php

namespace Teknisa\Models;

use NFePHP\NFe\Make;

class NFe { 
 
    protected $notaFiscal;
    protected $makeNFe; 
    
    const TAG_NAO_INFORMADA = "Tag [tagName] não informada";
 
    function __construct($notaFiscal) {
        $this->notaFiscal = $notaFiscal;
        $this->makeNFe    = new Make();
    }
    
    public function getXML() {

        foreach($this->notaFiscal as $tagName => $tagContent) {
            $this->criaTag($tagName, $tagContent);
        }

        $xml = $this->makeNFe->getXML();
        
        if(!$xml) {
            return array("ERROS" => $this->makeNFe->errors, "XML" => '');
        }

        return array("ERROS" => false, "XML" => $xml);
    }
    
    private function criaTag($tagName, $tagContent) {
        
        $stdTag = new \stdClass();
        
        $filhos = array();
        
        foreach($tagContent as $fieldName => $field) {
            switch(gettype($field)) {
                case 'object': 
                    $filhos[$fieldName] = $field;
                    break;
                case 'array': 
                    if($fieldName != '@attributes') {
                        $filhos[$fieldName] = $field;
                    }
                    break;
                default: 
                    $stdTag->$fieldName = $field;
            }
        }

        if($tagName != "0") {
            $tagName = 'tag'.$tagName;
            $this->makeNFe->$tagName($stdTag);
        }
        
        foreach ($filhos as $filhoName => $filhoValue) {
            if(gettype($filhoValue) == 'object') {
                $this->criaTag($filhoName, $filhoValue);
            }
            else {
                foreach($filhoValue as $filho) {
                    $this->criaTag($filhoName, $filho);
                }
            }
        }
        
    }
    
}